Subject: Re: bug#40538: installer: Support uvesafb to install on machines without KMS.

From: Bengt Richter <[email-masked]>
Date: Sun, 12 Apr 2020 08:37:02 +0200

Hi Ludo, Florian,

On +2020-04-10 16:58:58 +0200, pelzflorian (Florian Pelz) wrote:
> On Fri, Apr 10, 2020 at 04:38:37PM +0200, Ludovic Courtès wrote:
> > AIUI, uvesafb is needed for ksmcon (or presumably X11) to work, but it’s
> > not necessary to get the standard Linux framebuffer/console running
> > (indeed, you were able to ctrl-alt-f3 to get a terminal).  Is this
> > correct?
> 
> Yes, all correct.

Did you mean s/ksmcon/kmscon/ ? If that is a descendant of David Herrmann's work,
I wonder if it wouldn't just look for /sys/class/drm/card0 and, if found,
ignore /dev/fb0 and the uvesafb (along with the latter's user stuff requirements).

> 
> 
> > If that’s the case, then I think it’s acceptable for now to install a
> > system that lacks uvesafb.  Of course X11 won’t work (right?),
> 
> Yes, right.
>

Is that as absolutely right as it sounds?
I had thought that some version of Wayland/weston had a back end that
could run on plain /dev/fb0, and if so could provide Xwayland for X11 clients.

Of course, if /sys/class/drm/card0 is available, Wayland will prefer that,
and you're home free for all kinds of GUIs.

> > which is
> > not great, but people can hopefully address it at the console until we
> > have a better fix, possibly using ‘kernel-module-configuration-service’
> > as you write.
> > 
> > WDYT?
> 
> I agree.
> 
> I will try making a patch including your suggestions in a few hours.
> > 
> 
> >   2. Does "modprobe.d/uvesafb.conf" work?  I thought there was nothing
> >      taking care of creating “modprobe.d” automatically.
> 
> I think I tested this version of the patch and it worked.  One can
> test on QEMU by passing nomodeset (without uvesafb the installer stays
> black, I think).  It also matches the description of
> kernel-module-loader-service-type that was recently added to the
> manual.
> 
> Regards,
> Florian
> 
> 
> 

-- 
Regards,
Bengt Richter